# (c) 2006 Rico Schulte aka 3c5x9
# This Software is Free, use it where you want, when you want for whatever you want and modify it if you want but don't remove this two lines!
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http

import os
__version__ = "0.1"
class GrepResource(resource.Resource):
    
    title = "DMM7025 Screenshot"
    path2grep ="/usr/bin/grab"
    workfile = "/tmp/screenshot.bmp"
    
    def render(self, req):
        """ rendering server response """
        command = req.args.get("cmd",None)
        if command is None:
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "<form method=\"GET\">"
            html += "<input type=\"hidden\" name=\"cmd\" value=\"grep\">"
            html += "<select name=\"mode\">"
            html += "<option value=\"0\" selected>both</option>"
            html += "<option value=\"1\" >framebuffer only</option>"
            html += "<option value=\"2\" >video only</option>"
            html += "<input type=\"submit\" value=\"grep\">"
            html += "</select>"
            html += "</form></body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        
        elif command[0] == "grep":
            mode = int(req.args.get("mode","0")[0])
            self.grep(mode)
            picture = self.getPicture()
            if picture is False:
                text = "could not grab the image"
                return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=text)
            else:
                self.removePicture()
                return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('image', 'bmp')},stream=picture)
        else:
            html  = "<html><head><title>%s</title></head><body>" %self.title
            html += "unknown command %s"%command
            html += "</body></html>"
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
                
    def grep(self,type=0):
        """ exec system grab command with specified options 
            type 0 = video and osd
            type 1 = video only
            type 2 = osd"""
        if type is 1:
            cmdstr ="%s -o %s" %(self.path2grep,self.workfile)
        elif type is 2:
            cmdstr = "%s -v %s" %(self.path2grep,self.workfile)
        else:
            cmdstr = "%s %s" %(self.path2grep,self.workfile)
        return os.system(cmdstr)
    
    def getPicture(self):
        """ reading the picture from file to string and returning the string """
        try:
            f=open(self.workfile, 'rb')
            return f.read()
        except IOError:
            return False    
        
    def removePicture(self):
        """ removing grabbed picture """
        try:
            os.remove(self.workfile)
        except IOError:
            return False